/*
  Example1001A:Simple Servo Robot
  IRremote:Example602A + Example 902A
  
*/

#include <IRremote.h>
#include <FastLED.h>
#include <Servo.h> 

const int servoL_Pin = 9; 
const int servoR_Pin = 5;
Servo servoL; // left servo 
Servo servoR; // right servo 
// Left: 1530-1543:1536
//Right: 1490-1503:1496
int centerR=1510, centerL=1541, pw=800;

const int irRecvPin = 11;
const int ledPin=4;
CRGB leds[1];
IRrecv irrecv(irRecvPin);
decode_results results;

void setup(){
  delay(2000);
  LEDS.setBrightness(127); // 0-255
  FastLED.addLeds<WS2811, ledPin, GRB>(leds, 1);  
//  Serial.begin(9600);
  irrecv.enableIRIn();
  
  servoL.attach(servoL_Pin, centerL-pw, centerL+pw); // D9 
  servoR.attach(servoR_Pin, centerR-pw, centerR+pw); // D5 
}

int ledState = 0;

void fwd(int tau){
    servoL.write(10); 
    servoR.write(125); 
    delay(tau);   
}

void rot(int tau){
    servoL.write(170); 
    servoR.write(150); 
    delay(tau);     
}

void stp(int tau){
    servoL.write(90); 
    servoR.write(90); 
    delay(tau);   
}

void loop(){
  if (irrecv.decode(&results)){
    delay(200);
//    Serial.println(results.value, HEX);
    ledState = 1-ledState;
    if(ledState){
      leds[0]= CRGB(0, 0, 255);
      LEDS.show();
      fwd(2000);
    }else{
      leds[0]= CRGB(0, 0, 0);
      LEDS.show();
      stp(1000);
   }
    irrecv.resume();
  }
}
      
    
