/*
 * Example1002A: JJ2servo-Demo
 * H. kawakami October 22, 2014
 */

#include <IRremote.h>
#include "FastLED.h"
#include <Servo.h> 

const int servoL_Pin = 9; 
const int servoR_Pin = 5; 

Servo servoL; 
Servo servoR;

const int NUM_LEDS=1;
const int DATA_PIN=4;
CRGB leds[NUM_LEDS];

int RECV_PIN = 11;
IRrecv irrecv(RECV_PIN);
decode_results results;
unsigned res2;

unsigned getbits(unsigned long x, int p, int n){
  return (x>>(p+1-n))&~(~0<<n);
}

int centerR=1510, centerL=1541, pw=800;

void setup(){
  delay(2000);
  LEDS.setBrightness(64); // 0-255
  FastLED.addLeds<WS2811, DATA_PIN, GRB>(leds, NUM_LEDS);  

  Serial.begin(9600);
  irrecv.enableIRIn(); // Start the receiver
  
  delay(1000); 
  servoL.attach(servoL_Pin, centerL-pw, centerL+pw); // D9 
  servoR.attach(servoR_Pin, centerR-pw, centerR+pw); // D5 
  stp(1000);
}

void fwd(int tau){
    servoL.write(30); 
    servoR.write(150); 
    delay(tau);   
}
void bwd(int tau){
    servoL.write(150); 
    servoR.write(30); 
    delay(tau);   
}
void cw(int tau){
    servoL.write(30); 
    servoR.write(90); 
    delay(tau);   
}
void ccw(int tau){
    servoL.write(90); 
    servoR.write(150); 
    delay(tau);   
}
void stp(int tau){
    servoL.write(90); 
    servoR.write(90); 
    delay(tau);   
}

void loop() {
  if (irrecv.decode(&results)) {
    res2=getbits(results.value, 15,4);
    if(res2==0x5){
      fill_solid(&(leds[0]), 1, CRGB(0, 100, 0));
      LEDS.show();  
      fwd(2000); 
    }
    if(res2==0x9){
      fill_solid(&(leds[0]), 1, CRGB(100, 0, 0));
      LEDS.show();  
      ccw(2000); 
    }
    if(res2==0x6){
      fill_solid(&(leds[0]), 1, CRGB(0, 0, 100));
      LEDS.show();  
      cw(2000); 
    }
    if(res2==0x3){
      fill_solid(&(leds[0]), 1, CRGB(100, 100, 0));
      LEDS.show();  
      bwd(2000); 
    }
    if(res2==0xa){
      fill_solid(&(leds[0]), 1, CRGB(100, 100, 100));
      LEDS.show(); 
      stp(2000); 
    }
    if(res2==0xc){
      fill_solid(&(leds[0]), 1, CRGB(0, 0, 0));
      LEDS.show();  
      stp(2000); 
    }
    Serial.println(results.value, HEX);
    Serial.println(res2, HEX);
    irrecv.resume(); // Receive the next value
  }
}
